﻿var SCRIPT = {name:'ActiveClean', version:'v1'};

var L10N = L10N || (function()
	{
	var	__com = '// ', __sep = ' :: ', __beg = '<L10N>', __end = '</L10N>';

	var ln = (function()
		{ 
		for(var p in Locale) if(Locale[p] == this) return(p);
		}).call(app.locale);

	var parseL10N = /*str[]*/function(/*str*/locale_)
		{ 
		var line, lines=[], r=[];
		var uEsc = function(){return String.fromCharCode(Number('0x'+arguments[1]));}
		if( this.open('r') )
			{
			var comSize=__com.length;
			while( !this.eof )
				{
				line = this.readln().replace(/\\u([0-9a-f]{4})/gi, uEsc);
				if( line.indexOf(__com) != 0 ) continue;
				if( line.indexOf(__end) >= 0 ) break;
				if( line.indexOf(__sep) < 0  ) continue;
				lines.push(line.substr(comSize).split(__sep));
				}
			this.close();
			}

		var locIndex = (function()
			{ 
			while( (line=this.shift()) && line[0] != __beg ) {};
			if (!line) return false;
			for (var i=1,sz=line.length ; i<sz ; i++)
				if ( line[i] == locale_ ) return i;
			return 0;
			}).call(lines);
		if (!locIndex) return r;
		
		while( line=lines.shift() )
			if ( typeof line[locIndex] != 'undefined' )
				r[line[0]] = line[locIndex];
		return r;
		}
	
	var tb = parseL10N.call(File(app.activeScript),ln);
	__ = function(/*str*/ks){return(tb[ks]||ks);}
	return {locale: ln};
	})();

var UNITS = (function()
	{
	var r={}, mu=MeasurementUnits;
	r[mu.AGATES]='agt';
	r[mu.CENTIMETERS]='cm';
	r[mu.CICEROS]='ci';
	r[mu.INCHES]='in';
	r[mu.INCHES_DECIMAL]='in';
	r[mu.MILLIMETERS]='mm';
	r[mu.PICAS]='pc';
	r[mu.POINTS]='pt';
	return(r);
	})();

Application.prototype.showUI = function()

	{
	var dlg = this.dialogs.add( {name: ' '+SCRIPT.name+'  '+SCRIPT.version, canCancel: true} );
	var PREF_UNITS = MeasurementUnits.MILLIMETERS;
	
	var rgOffsets, meOffset, cbMaster;
	with ( dlg ) 
		{
 		with ( dialogColumns.add().borderPanels.add().dialogColumns.add() )
 			{
   			staticTexts.add( {staticLabel:__("Supprimer les objets au-del\u00E0 de : ")} );
   			with ( (rgOffsets=radiobuttonGroups.add()).radiobuttonControls )
   				{
   				add( {staticLabel: __("Fonds perdus")} );
   				add( {staticLabel: __("Ligne-bloc") } );
   				add( {staticLabel: __("Distance de la page : "), checkedState:true} );
   				}
   			meOffset = measurementEditboxes.add( {editUnits: PREF_UNITS, editValue:0, smallNudge:1 });
   			cbMaster = checkboxControls.add( {staticLabel:__("Inclure les gabarits")} );
  			}
		}
	
	var r = ( dlg.show() ) ?
			{
			choice: rgOffsets.selectedButton,
			customOffset: meOffset.editValue,
			parseMaster: cbMaster.checkedState
			} : false;

	dlg.destroy();
	return(r);
	}

DocumentPreference.prototype.bsOffsets = function(/*[0=Bleed|1=Slug]*/bsOption)

	{
	var bs = (bsOption)?'slug':'documentBleed';
	var right = (bsOption)?'RightOrOutsideOffset':'OutsideOrRightOffset';
	return [ this[bs+'TopOffset'], this[bs+'InsideOrLeftOffset'],
		this[bs+'BottomOffset'], this[bs+right] ];
	}

ViewPreference.prototype.toOffsets = function(/*num*/ptsValue)

	{
	var uv = UnitValue(ptsValue, 'pt');
	var h = uv.as(UNITS[this.horizontalMeasurementUnits]);
	var v = uv.as(UNITS[this.verticalMeasurementUnits]);
	return [v,h,v,h];
	}

Document.prototype.cleanOut = function(/*arr*/offsets, /*bool*/parseMaster)

	{
	var outOf = function(b)
		{ 
		return this[2]<b[0] || this[3]<b[1] || this[0]>b[2] || this[1]>b[3];
		}
	
	var extraBounds = function()
		{ 
		var bFirst = this.pages.item(0).bounds; 
		
		var bLast = this.pages.item(-1).bounds;
		return [ bFirst[0]-offsets[0], bFirst[1]-offsets[1],
			bLast[2]+offsets[2], bLast[3]+offsets[3] ];
		};

	var spreads = this.spreads.everyItem().getElements();
	if (parseMaster)
		spreads = spreads.concat(this.masterSpreads.everyItem().getElements());
	
	var cpt=0;
	var i, s, iBounds, eBounds, items;

	var ro = this.viewPreferences.rulerOrigin;
	this.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;

	while(s=spreads.pop())	
		{
		eBounds = extraBounds.call(s);	
		items = s.pageItems.everyItem().getElements();
		while(i=items.pop())	
			{
			if ( outOf.call(i.visibleBounds,eBounds) )
				try {i.remove();cpt++} catch(ex){};
			}
		}
	this.viewPreferences.rulerOrigin = ro;
	return(cpt);
 	}

Application.prototype.main = function()

	{
	if (! this.documents.length ) return;

	var ui = app.showUI();
	if (! ui ) return;

	var doc = this.activeDocument;
	var offsets = ( ui.choice > 1 ) ?
		doc.viewPreferences.toOffsets(ui.customOffset) :
		doc.documentPreferences.bsOffsets(ui.choice);

	alert(__("Objets supprimés : ") + ' ' + doc.cleanOut(offsets, ui.parseMaster));
	}

if ( parseInt(app.version) >= 6)
	{ 
	app.doScript('app.main();', ScriptLanguage.javascript,
	undefined, UndoModes.entireScript, app.activeScript.displayName);
	}
else
	{ 
	app.main();
	}